function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
import { useUpdateEffect } from 'ahooks';

/**
 * 自动滚动到底部
 */
export var useAutoScrollToBottom = function useAutoScrollToBottom(container, _ref) {
  var _ref$effect = _ref.effect,
    effect = _ref$effect === void 0 ? [] : _ref$effect,
    patch = _ref.patch;
  useUpdateEffect(function () {
    if (!container) return;
    if (typeof patch === 'function' && !patch()) {
      return;
    }
    // 等价于nextick
    requestAnimationFrame(function () {
      setTimeout(function () {
        var _document;
        //@ts-ignore
        // 检测是否处于IE兼容模式
        if ((_document = document) !== null && _document !== void 0 && _document.documentMode) {
          container.scrollTop = container.clientHeight + container.scrollTop;
        } else {
          container.scrollTop = container.scrollHeight;
        }
      }, 5);
    });
  }, _toConsumableArray(effect));
};