import { SetStateAction } from 'react';
/**
 * 延迟创建状态，直到满足某些条件。
 * @param initialState 初始的state
 * @param condition 是否满足穿创建初始值的条件
 */
declare const useDelayedState: <T = any>(initialState: T, condition: boolean) => [T | undefined, (newState: SetStateAction<T>) => void];
export default useDelayedState;
