function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
import { useLatest, useRafState } from 'ahooks';
import { getTargetElement } from "../utils";
import { useLayoutEffect, useRef } from 'react';
function getBounding(ele, val) {
  var _ele$getBoundingClien = ele.getBoundingClientRect(),
    elWidth = _ele$getBoundingClien.width,
    elHeight = _ele$getBoundingClien.height;
  var bounding = {
    maxX: document.documentElement.clientWidth - elWidth,
    maxY: document.documentElement.clientHeight - elHeight
  };
  if (val === 'parent' && ele.parentElement) {
    var _ele$parentElement$ge = ele.parentElement.getBoundingClientRect(),
      width = _ele$parentElement$ge.width,
      height = _ele$parentElement$ge.height;
    ele.parentElement.style.position = 'relative';
    ele.style.position = 'absolute';
    bounding.maxX = width - elWidth;
    bounding.maxY = height - elHeight;
  } else if (val && _typeof(val) === 'object' && typeof val.getBoundingClientRect === 'function') {
    var _val$getBoundingClien = val.getBoundingClientRect(),
      _width = _val$getBoundingClien.width,
      _height = _val$getBoundingClien.height;
    ele.style.position = 'absolute';
    bounding.maxX = _width - elWidth;
    bounding.maxY = _height - elHeight;
  } else {
    ele.style.position = 'fixed';
  }
  return bounding;
}

/**
 * 高性能的可拖动组件的钩子函数。
 *
 * 支持 `PC端` `移动端`和`触控笔设备`。
 *
 * 该函数使指定的元素具有拖动功能，并可根据配置限制拖动范围和初始位置。
 *
 * @param ele - 要拖动的元素或其选择器
 * @param opts - 配置选项，包括拖动范围等
 * @returns 包含当前坐标和是否正在拖动的对象
 */
export default function useDraggable(ele, opts) {
  var _useRafState = useRafState(function () {
      return (opts === null || opts === void 0 ? void 0 : opts.defaultPosition) || {
        x: 0,
        y: 0
      };
    }),
    _useRafState2 = _slicedToArray(_useRafState, 2),
    xy = _useRafState2[0],
    setXY = _useRafState2[1];
  // 使用最新的 x, y
  var xyRef = useLatest(xy);
  var _useRafState3 = useRafState(false),
    _useRafState4 = _slicedToArray(_useRafState3, 2),
    moving = _useRafState4[0],
    setMoving = _useRafState4[1];
  var movingRef = useLatest(moving);
  var offsetRef = useRef((opts === null || opts === void 0 ? void 0 : opts.defaultPosition) || {
    x: 0,
    y: 0
  });
  useLayoutEffect(function () {
    var el = getTargetElement(ele);
    if (!el) return;
    el.style.cursor = 'grab';
    el.style.userSelect = 'none';
    el.style.touchAction = 'none';
    el.style.transform = "translate(".concat(xy.x, "px, ").concat(xy.y, "px)");
    var _getBounding = getBounding(el, (opts === null || opts === void 0 ? void 0 : opts.bounding) || 'viewport'),
      maxX = _getBounding.maxX,
      maxY = _getBounding.maxY;
    var handleDown = function handleDown(e) {
      var _opts$onStart;
      e.preventDefault();
      el.setPointerCapture(e.pointerId);
      el.style.cursor = 'grabbing';
      offsetRef.current.x = e.clientX - offsetRef.current.x;
      offsetRef.current.y = e.clientY - offsetRef.current.y;
      opts === null || opts === void 0 ? void 0 : (_opts$onStart = opts.onStart) === null || _opts$onStart === void 0 ? void 0 : _opts$onStart.call(opts, {
        x: xyRef.current.x,
        y: xyRef.current.y
      }, e);
      var handleMove = function handleMove(e) {
        var _opts$onMove;
        e.preventDefault();
        var newLeft = e.clientX - offsetRef.current.x;
        var newTop = e.clientY - offsetRef.current.y;
        // 计算新的位置并应用边界检查
        if (newLeft < 0) {
          newLeft = 0;
        }
        if (newLeft > maxX) {
          newLeft = maxX;
        }
        if (newTop < 0) {
          newTop = 0;
        }
        if (newTop > maxY) {
          newTop = maxY;
        }
        el.style.transform = "translate(".concat(newLeft, "px, ").concat(newTop, "px)");
        opts === null || opts === void 0 ? void 0 : (_opts$onMove = opts.onMove) === null || _opts$onMove === void 0 ? void 0 : _opts$onMove.call(opts, {
          x: newLeft,
          y: newTop
        }, e);
        setXY({
          x: newLeft,
          y: newTop
        });
        if (!movingRef.current) {
          setMoving(true);
        }
      };
      var handleUp = function handleUp(e) {
        var _opts$onEnd;
        e.preventDefault();
        el.releasePointerCapture(e.pointerId);
        el.style.cursor = 'grab';
        offsetRef.current.x = xyRef.current.x;
        offsetRef.current.y = xyRef.current.y;
        setMoving(false);
        opts === null || opts === void 0 ? void 0 : (_opts$onEnd = opts.onEnd) === null || _opts$onEnd === void 0 ? void 0 : _opts$onEnd.call(opts, {
          x: xyRef.current.x,
          y: xyRef.current.y
        }, e);
        el.removeEventListener('pointermove', handleMove);
        el.removeEventListener('pointerup', handleUp);
      };
      el.addEventListener('pointermove', handleMove, false);
      el.addEventListener('pointerup', handleUp, false);
    };
    el.addEventListener('pointerdown', handleDown, false);
    return function () {
      el.removeEventListener('pointerdown', handleDown);
    };
  }, [opts === null || opts === void 0 ? void 0 : opts.bounding]);
  return _objectSpread(_objectSpread({}, xy), {}, {
    moving: moving
  });
}