import { getTargetElement } from "../utils";
import { MutableRefObject } from 'react';
export type UseLazyImageParams = {
    /** querySelectorAll抓取页面上所有可延迟加载的图像 */
    imageAttribute?: `data-${string}`;
    /** 在哪个节点下查询 querySelectorAll 默认为整个视口*/
    target?: Parameters<typeof getTargetElement>[0];
    /** IntersectionObserver 的配置项*/
    options?: Omit<IntersectionObserverInit, 'root'> & {
        root?: MutableRefObject<HTMLElement | null> | (() => HTMLElement);
    };
    /** 依赖项 如果配置会在更新时重新执行监听 */
    dependencies?: any[];
};
/**
 * 用于实现图片的懒加载功能
 * @param params 配置参数，包括图片属性、目标元素、IntersectionObserver的选项和依赖项
 */
export default function useLazyImage(params?: UseLazyImageParams): void;
