function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useState } from 'react';
import useResizeObserver from "../useResizeObserver";
var defaultState = {
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  top: 0,
  left: 0,
  bottom: 0,
  right: 0
};

/**
 * 用于测量HTML元素的`尺寸`和`位置`
 *
 * `ahooks` 的 `useSize` 只会返回 width 和 height
 *
 * 它基于Resize Observer API，提供了一种简单的方法来获取元素的实时大小和位置信息
 *
 * @param target 要测量的HTML元素的引用，可以是MutableRefObject类型或者返回HTMLElement的函数
 * @param options 传递给ResizeObserver的选项，用于配置观察行为
 * @returns 返回一个包含元素尺寸和位置信息的矩形对象，以及一个用于停止观察的函数
 */
var useMeasure = function useMeasure(target, options) {
  var _useState = useState(defaultState),
    _useState2 = _slicedToArray(_useState, 2),
    rect = _useState2[0],
    setRect = _useState2[1];
  useResizeObserver(target || document.body, function (entries) {
    if (entries[0]) {
      var _entries$0$contentRec = entries[0].contentRect,
        x = _entries$0$contentRec.x,
        y = _entries$0$contentRec.y,
        width = _entries$0$contentRec.width,
        height = _entries$0$contentRec.height,
        top = _entries$0$contentRec.top,
        left = _entries$0$contentRec.left,
        bottom = _entries$0$contentRec.bottom,
        right = _entries$0$contentRec.right;
      setRect({
        x: x,
        y: y,
        width: width,
        height: height,
        top: top,
        left: left,
        bottom: bottom,
        right: right
      });
    }
  }, options);
  return rect;
};
export default useMeasure;