function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useEventListener } from 'ahooks';
import { useState } from 'react';
/**
 * 监听页面离开事件，当鼠标移出页面或页面失去焦点时返回 true。
 *
 * 只要鼠标不在文档中，就认为页面已离开。包含`鼠标在标签页`或者`调试台`或者`切换浏览器标签页`
 *
 * @returns 返回页面是否已离开，如果鼠标移出页面或页面失去焦点则返回 true，否则返回 false。
 */
export default function usePageLeave() {
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isLeft = _useState2[0],
    setIsLeft = _useState2[1];
  var handler = function handler(event) {
    // eslint-disable-next-line no-param-reassign
    event = event || window.event;
    // @ts-ignore
    var from = event.relatedTarget || event.toElement;
    setIsLeft(!from);
  };
  useEventListener('mouseout', handler, {
    target: function target() {
      return window;
    },
    passive: true
  });
  useEventListener('mouseleave', handler, {
    target: function target() {
      return document;
    },
    passive: true
  });
  useEventListener('mouseenter', handler, {
    target: function target() {
      return document;
    },
    passive: true
  });
  return isLeft;
}