import { getTargetElement } from "../utils";
/**
 * 用于观察指定元素的尺寸变化并调用回调函数
 *
 * 主要用途是封装ResizeObserver，使其更方便地在React组件中使用
 *
 * @param target 要观察其尺寸变化的元素的引用或选择器
 * @param callback 当观察的元素尺寸变化时的回调函数
 * @param options ResizeObserver的配置选项
 */
declare const useResizeObserver: (target: Parameters<typeof getTargetElement>[0], callback: ResizeObserverCallback, options?: ResizeObserverOptions) => () => void;
export default useResizeObserver;
