import { getTargetElement } from "../utils";
interface UseSlideVerifyReturn {
    moveX: number;
    reset: () => void;
    moveing: boolean;
}
interface UseSlideVerifyOptions {
    initX?: number;
    maxMoveX?: number;
    onMouseDown?: (moveX: number) => void;
    onMouseMove?: (moveX: number) => void;
    onMouseUp?: (moveX: number) => void;
}
/**
 * 用于滑块验证滑动距离的 hook
 * 支持 PC 端、移动端、触摸笔
 * @param {(target: (() => HTMLElement) | React.RefObject<HTMLElement>) => HTMLElement} target 验证滑块的 DOM
 * @param {{
 *     initX?: number;
 *     maxMoveX?: number;
 *     onMouseDown?: (moveX: number) => void;
 *     onMouseMove?: (moveX: number) => void;
 *     onMouseUp?: (moveX: number) => void;
 *   }} options 配置项
 */
export default function useSlideVerify(target: Parameters<typeof getTargetElement>[0], { initX, maxMoveX, onMouseDown, onMouseMove, onMouseUp, }?: UseSlideVerifyOptions): UseSlideVerifyReturn;
export {};
