declare function getSize(): {
    innerHeight: number;
    innerWidth: number;
    outerHeight: number;
    outerWidth: number;
    dpr: number;
};
/**
 * 使用窗口 大小 和 dpr 变化的 Hook
 * @param fn 窗口大小变化时的回调函数，可选参数
 * @param waitTime 防抖的等待时间，默认为 200 毫秒
 * @returns 当前窗口的大小以及dpr
 */
export default function useWindowSize(fn?: (size: ReturnType<typeof getSize>) => void, waitTime?: number): {
    innerHeight: number;
    innerWidth: number;
    outerHeight: number;
    outerWidth: number;
    dpr: number;
};
export {};
